// --------------------------------------------------------
// Copyright (c)
//
// contributions by author
//                  author@somewhere.net
// maintained by    CEA LIST
//                  info-list@cea.fr

// --------------------------------------------------------
// Code generated by Papyrus C++
// --------------------------------------------------------

#include "periodicPublisherCompdef/PeriodicPublisher.h"

using namespace std::chrono_literals;
// declare options
rclcpp::NodeOptions periodicpublisher_options;

int main(int argc, char **argv) {
  rclcpp::init(argc, argv);

  auto periodicpublisher = std::make_shared
      < periodicPublisherCompdef::PeriodicPublisher
      > (periodicpublisher_options);

  RCLCPP_INFO(periodicpublisher->get_logger(),
      "PeriodicPublisher has been initialized");

  periodicpublisher->register_on_activate(
      [&periodicpublisher](const rclcpp_lifecycle::State&) {
        // periodic execution (250ms) for Activity1 using a wall timer
        // create a callback group for the timer
        periodicpublisher->timer_Activity1_ =
            periodicpublisher->create_wall_timer(250ms,
                std::bind(
                    &periodicPublisherCompdef::PeriodicPublisher::fPublishing,
                    periodicpublisher), periodicpublisher->cbg_t_Activity1_);
        return rclcpp_lifecycle::node_interfaces::LifecycleNodeInterface::CallbackReturn::SUCCESS;
      }
  );
  periodicpublisher->register_on_deactivate(
      [&periodicpublisher](const rclcpp_lifecycle::State&) {
        // stop timer of Activity1
        periodicpublisher->timer_Activity1_->cancel();
        return rclcpp_lifecycle::node_interfaces::LifecycleNodeInterface::CallbackReturn::SUCCESS;
      }
  );
  periodicpublisher->register_on_shutdown(
      [&periodicpublisher](const rclcpp_lifecycle::State&) {
        // stop timer of Activity1
        periodicpublisher->timer_Activity1_->cancel();
        return rclcpp_lifecycle::node_interfaces::LifecycleNodeInterface::CallbackReturn::SUCCESS;
      }
  );
  periodicpublisher->declareParameters();
  periodicpublisher->initParameterVars();

  rclcpp::executors::MultiThreadedExecutor executor;

  executor.add_node(periodicpublisher->get_node_base_interface());

  executor.spin();
  rclcpp::shutdown();
}

